.686
.model flat,stdcall
option casemap:none
.xmm

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib


.data
ALIGN 16
   A0  dd 8 dup (-1)  ; x0 is for values
   B0  dd 8 dup (0)
   C1  dd 4 dup (0)   ; x1 is for carries

                       ;   AM  dd  0, 0, 1, 0
   AC  dd  1, 0, 0, 0  ;   AP
   AF  dd -1, 0,-1, 0  ;   AN
                       ;   AQ  dd -1,-1, 0, 0
                       ;   AR  dd  0, 0,-1,-1

   szfmtD db "%lu",13,10
          db "%lu",13,10
          db "%lu",13,10
          db "%lu",13,10
          db "%lu",0

   szC    db "The Caption",0
   szM    db "The Message ",13,10
   szZ    db 256 dup (0)


.code
start:
 ;     stc                ; set   carry flag == 1
 ;     clc                ; clear carry flag == 0
 ;     bt   eax, 0        ; carry flag == bit 0 of eax

    mov  A0, -2
    mov  B0,  1

    mov  A0+8, -2
    mov  B0+8,  1


 ;     stc              ; set carry just in testing
 ;
 ;     mov eax, B0+ 0   ; ALU version
 ;     mov ebx, B0+ 4
 ;     mov ecx, B0+ 8
 ;     mov edx, B0+12
 ;     adc A0+ 0, eax
 ;     adc A0+ 4, ebx
 ;     adc A0+ 8, ecx
 ;     adc A0+12, edx


    ; bt   C1, 0         ; carry flag == bit 0 of C1

    stc                ; set carry  Normally NOT done,  Only used for Testing

    setc byte ptr C1   ; bit 0 from low byte in C1, from the carry flag   0 or 1  if carry Clear == 0 else Set == 1


    invoke wsprintf,ADDR szZ,ADDR szfmtD, C1, A0, A0+4, A0+8, A0+12    ; debugging code
    invoke MessageBox, NULL, addr szM, addr szC, MB_OK
    mov ecx, 64
    .repeat
       dec ecx
       mov [szZ+ecx*4], 0
    .until ecx == 0


 ;    AM  dd  0, 0, 1, 0   _1__
 ;
 ;    AC  dd  1, 0, 0, 0   ___1
 ;    AF  dd -1, 0,-1, 0   _F_F
 ; 
 ;    AQ  dd -1,-1, 0, 0   __FF
 ;    AR  dd  0, 0,-1,-1   FF__

    movdqa  xmm4, oword ptr [A0 +  0]             ; YYXX
    movdqa  xmm5, oword ptr [B0 +  0]             ; yyxx

    movdqa  xmm7, oword ptr [AF +  0]             ; _F_F

    pshufd  xmm0, xmm4, 11011000b  ; 3120 <-- 3210  +1+0  LOW
    pshufd  xmm1, xmm5, 11011000b  ; 3120 <-- 3210  +1+0
    pshufd  xmm2, xmm4, 00110110b  ; 0312 <-- 3210  +3+2  HIGH
    pshufd  xmm3, xmm5, 00110110b  ; 0312 <-- 3210  +3+2

    andpd   xmm0, xmm7  ;  _X_X
    andpd   xmm1, xmm7
    andpd   xmm2, xmm7
    andpd   xmm3, xmm7

    movdqa  xmm4, oword ptr [AC +  0]  ; 0001
    pshufd  xmm5, xmm4, 11000110b      ; 0100  ; oword ptr [AM +  0]  ; 3012 <-- 3210

    movdqa  xmm6, oword ptr [C1 +  0]  ; get carry
    andpd   xmm6, xmm4                 ; 000v  only bit 0 allowed
                                       ; movdqa  xmm4, oword ptr [AC +  0]
                                       ; movdqa  xmm5, oword ptr [AM +  0]
                                       ; movdqa  xmm7, oword ptr [AM +  0]
    paddq   xmm0, xmm1             ; A lo + B lo
    paddq   xmm0, xmm6             ; A lo + carry

    pshufd  xmm6, xmm0, 11011000b  ; _c__ <-- __c_   3120 <-- 3210
    andpd   xmm6, xmm5             ; 0c00  AM
    paddq   xmm0, xmm6             ; A lo + 0c00

    pshufd  xmm6, xmm0, 00100111b  ; ___3 <-- 3___   0213 <-- 3210  move carry in 3 to 0
    andpd   xmm6, xmm4             ; oword ptr [AC +  0]   ; carry from ___c



    paddq   xmm2, xmm3             ; A hi + B hi
    paddq   xmm2, xmm6             ; A hi + carry from lo

    pshufd  xmm6, xmm2, 11011000b  ; _c__ <-- __c_   3120 <-- 3210
    andpd   xmm6, xmm5             ; 0c00  AM
    paddq   xmm2, xmm6             ; A hi + 0c00

    pshufd  xmm6, xmm0, 00100111b  ; ___3 <-- 3___   0213 <-- 3210  move carry 3 to 0
    andpd   xmm6, xmm4             ; oword ptr [AC +  0]   ; carry  from ___c

    movdqa  oword ptr [C1 + 0], xmm6



    pshufd  xmm4, xmm0, 11011000b  ; __20 <-- _2_0   3120 <-- 3210
    pshufd  xmm5, xmm2, 10001101b  ; 20__ <-- _2_0   2031 <-- 3210

    pshufd  xmm6, xmm7, 11011000b  ; __XX <-- _X_X   3120 <-- 3210   
    andpd   xmm4, xmm6             ; __xx  oword ptr [AQ + 0]

    pshufd  xmm7, xmm6, 10001110b  ; YY__ <-- _Y_Y   1032 <-- 3210   
    andpd   xmm5, xmm7             ; yy__  oword ptr [AR + 0]

                ; andpd   xmm7, oword ptr [AQ + 0]
                ; andpd   xmm6, oword ptr [AR + 0]

    paddq   xmm5, xmm4             ; yyxx
    movdqa  oword ptr [A0 + 0], xmm5
    bt      C1, 0                  ; carry flag == bit 0 of C1

    invoke wsprintf,ADDR szZ,ADDR szfmtD, A0, A0+4, A0+8, A0+12, C1    ; debugging code
    invoke MessageBox, NULL, addr szM, addr szC, MB_OK

   invoke ExitProcess, 0
end start